action :before_compile do
end

action :before_deploy do
end

action :before_migrate do
  directory "#{new_resource.path}/shared/vendor_bundle" do
    owner new_resource.owner
    group new_resource.group
    mode '0755'
  end

  directory "#{new_resource.release_path}/vendor" do
    owner new_resource.owner
    group new_resource.group
    mode '0755'
  end

  link "#{new_resource.release_path}/vendor/bundle" do
    to "#{new_resource.path}/shared/vendor_bundle"
  end

  common_groups = %w{development test cucumber staging production}
  common_groups -= [new_resource.environment_name]
  common_groups += new_resource.bundler_without_groups
  common_groups = common_groups.join(' ')

  command = "#{new_resource.bundle_command} install --path=vendor/bundle --without #{common_groups}"
  command += ' --deployment' if new_resource.bundler_deployment
  command += " #{new_resource.bundle_options}"

  execute command do
    cwd new_resource.release_path
    user new_resource.owner
    environment new_resource.environment
  end
end

action :before_symlink do
end

action :before_restart do
end

action :after_restart do
end
